国内最全IT社区平台 联系我们 | 收藏本站
华晨云阿里云优惠2
您当前位置:首页 > 互联网 > hdu 1227(经典dp)

hdu 1227(经典dp)

来源:程序员人生   发布时间:2014-09-29 15:03:00 阅读次数:3349次

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1227

Fast Food

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2165    Accepted Submission(s): 926


Problem Description
The fastfood chain McBurger owns several restaurants along a highway. Recently, they have decided to build several depots along the highway, each one located at a restaurant and supplying several of the restaurants with the needed ingredients. Naturally, these depots should be placed so that the average distance between a restaurant and its assigned depot is minimized. You are to write a program that computes the optimal positions and assignments of the depots.

To make this more precise, the management of McBurger has issued the following specification: You will be given the positions of n restaurants along the highway as n integers d1 < d2 < ... < dn (these are the distances measured from the company's headquarter, which happens to be at the same highway). Furthermore, a number k (k <= n) will be given, the number of depots to be built.

The k depots will be built at the locations of k different restaurants. Each restaurant will be assigned to the closest depot, from which it will then receive its supplies. To minimize shipping costs, the total distance sum, defined as



must be as small as possible.

Write a program that computes the positions of the k depots, such that the total distance sum is minimized.
 

Input
The input file contains several descriptions of fastfood chains. Each description starts with a line containing the two integers n and k. n and k will satisfy 1 <= n <= 200, 1 <= k <= 30, k <= n. Following this will n lines containing one integer each, giving the positions di of the restaurants, ordered increasingly.

The input file will end with a case starting with n = k = 0. This case should not be processed.
 

Output
For each chain, first output the number of the chain. Then output a line containing the total distance sum.

Output a blank line after each test case.
 

Sample Input
6 3 5 6 12 19 20 27 0 0
 

Sample Output
Chain 1 Total distance sum = 8
 

Source
Southwestern Europe 1998
 题意:一条直线上有n家餐馆,现在要在这n家餐馆中选出k个来建立仓库,每家餐馆都会就近选择一个仓库,使得最小;
思路:分析一下, 用 dp[i][j] 表示前j家餐馆修建i个仓库的值最小,那么当修建第i个仓库的时候,前i-1个仓库肯定修好了,所以用dp[i-1][k]来表示前k家餐馆修建i-1个仓库的最小值,那么容易知道  i-1<=k<j;
所以得到状态转移方程:
dp[i][j]=min(dp[i-1][k]+cost[k+1][j]);
PS:cost[i][j]表示在第i家餐馆到第j家餐馆修建一个仓库的最小值,那么肯定修建在 (i+j)/2处才是最优的;所以预处理一下cost即可;
#include <iostream> #include <stdio.h> #include <string.h> #include <string> #include <cstdio> #include <cmath> #include <algorithm> const int INF=99999999; using namespace std; int dp[33][220]; int a[220]; int cost[220][220]; int main() { int n,m,test=1; while(cin>>n>>m) { if(n==0&&m==0)break; for(int i=1;i<=n;i++)cin>>a[i]; //预处理一下 memset(cost,0,sizeof(cost)); for(int i=1;i<=n;i++) for(int j=i+1;j<=n;j++) { for(int k=i;k<=j;k++) cost[i][j]+=fabs(a[k]-a[(i+j)/2]); } memset(dp,0,sizeof(dp)); for(int i=1;i<=n;i++)dp[1][i]=cost[1][i]; //dp for(int i=2;i<=m;i++) for(int j=i+1;j<=n;j++) { dp[i][j]=INF; for(int k=i-1;k<j;k++) dp[i][j]=min(dp[i][j],dp[i-1][k]+cost[k+1][j]); } printf("Chain %d ",test++); printf("Total distance sum = %d ",dp[m][n]); } return 0; }


生活不易,码农辛苦
如果您觉得本网站对您的学习有所帮助,可以手机扫描二维码进行捐赠
程序员人生
------分隔线----------------------------
分享到:
------分隔线----------------------------
关闭
程序员人生